| Flutter Linux Embedder |

Classes | Functions | Variables
fl_settings_plugin.cc File Reference
`#include "flutter/shell/platform/linux/fl_settings_plugin.h"`
`#include <gmodule.h>`
`#include "flutter/shell/platform/embedder/embedder.h"`
`#include "flutter/shell/platform/linux/fl_engine_private.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_basic_message_channel.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_binary_messenger.h"`
`#include "flutter/shell/platform/linux/public/flutter_linux/fl_json_message_codec.h"`

Go to the source code of this file.

## Classes
struct | _FlSettingsPlugin

## Functions
static const gchar * | to_platform_brightness (FlColorScheme color_scheme)
static void | update_settings (FlSettingsPlugin *self)
static void | fl_settings_plugin_dispose (GObject *object)
static void | fl_settings_plugin_class_init (FlSettingsPluginClass *klass)
static void | fl_settings_plugin_init (FlSettingsPlugin *self)
FlSettingsPlugin * | fl_settings_plugin_new (FlEngine *engine)
void | fl_settings_plugin_start (FlSettingsPlugin *self, FlSettings *settings)

## Variables
static constexpr char | kChannelName [] = "flutter/settings"
static constexpr char | kTextScaleFactorKey [] = "textScaleFactor"
static constexpr char | kAlwaysUse24HourFormatKey [] = "alwaysUse24HourFormat"
static constexpr char | kPlatformBrightnessKey [] = "platformBrightness"
static constexpr char | kPlatformBrightnessLight [] = "light"
static constexpr char | kPlatformBrightnessDark [] = "dark"

## Function Documentation

## ◆ fl_settings_plugin_class_init()

static void fl_settings_plugin_class_init | ( | FlSettingsPluginClass * | klass | ) |
| static

Definition at line 88 of file fl_settings_plugin.cc.

88 {
89 G_OBJECT_CLASS(klass)->dispose = fl_settings_plugin_dispose;
90 }

References fl_settings_plugin_dispose().

## ◆ fl_settings_plugin_dispose()

static void fl_settings_plugin_dispose | ( | GObject * | object | ) |
| static

Definition at line 73 of file fl_settings_plugin.cc.

73 {
74 FlSettingsPlugin* self = FL_SETTINGS_PLUGIN(object);
75
76 g_clear_object(&self->channel);
77 g_clear_object(&self->settings);
78
79 if (self->engine != nullptr) {
80 g_object_remove_weak_pointer(G_OBJECT(self),
81 reinterpret_cast<gpointer*>(&(self->engine)));
82 self->engine = nullptr;
83 }
84
85 G_OBJECT_CLASS(fl_settings_plugin_parent_class)->dispose(object);
86 }

References self.

Referenced by fl_settings_plugin_class_init().

## ◆ fl_settings_plugin_init()

static void fl_settings_plugin_init | ( | FlSettingsPlugin * | self | ) |
| static

Definition at line 92 of file fl_settings_plugin.cc.

92 {}

## ◆ fl_settings_plugin_new()

FlSettingsPlugin* fl_settings_plugin_new | ( | FlEngine * | engine | ) |

FlSettingsPlugin:

#FlSettingsPlugin is a plugin that implements the Flutter user settings channel. fl_settings_plugin_new: @messenger: an #FlEngine

Creates a new plugin that sends user settings to the Flutter engine.

Returns: a new #FlSettingsPlugin

Definition at line 94 of file fl_settings_plugin.cc.

94 {
95 g_return_val_if_fail(FL_IS_ENGINE(engine), nullptr);
96
97 FlSettingsPlugin* self =
98 FL_SETTINGS_PLUGIN(g_object_new(fl_settings_plugin_get_type(), nullptr));
99
100 self->engine = engine;
101 g_object_add_weak_pointer(G_OBJECT(self),
102 reinterpret_cast<gpointer*>(&(self->engine)));
103
104 FlBinaryMessenger* messenger = fl_engine_get_binary_messenger(engine);
105 g_autoptr(FlJsonMessageCodec) codec = fl_json_message_codec_new();
106 self->channel = fl_basic_message_channel_new(messenger, kChannelName,
107 FL_MESSAGE_CODEC(codec));
108
109 return self;
110 }

References engine, fl_basic_message_channel_new(), fl_engine_get_binary_messenger(), fl_json_message_codec_new(), g_object_add_weak_pointer(), kChannelName, and self.

Referenced by fl_engine_start(), and TEST().

## ◆ fl_settings_plugin_start()

void fl_settings_plugin_start | ( | FlSettingsPlugin * | plugin,
|  | FlSettings * | settings
| ) |  |

fl_settings_plugin_start: @self: an #FlSettingsPlugin.

Sends the current settings to the engine and updates when they change.

Definition at line 112 of file fl_settings_plugin.cc.

112 {
113 g_return_if_fail(FL_IS_SETTINGS_PLUGIN(self));
114 g_return_if_fail(FL_IS_SETTINGS(settings));
115
116 self->settings = FL_SETTINGS(g_object_ref(settings));
117 g_signal_connect_object(settings, "changed", G_CALLBACK(update_settings),
118 self, G_CONNECT_SWAPPED);
119
120 update_settings(self);
121 }

References update_settings().

Referenced by fl_engine_start(), and TEST().

## ◆ to_platform_brightness()

static const gchar* to_platform_brightness | ( | FlColorScheme | color_scheme | ) |
| static

Definition at line 32 of file fl_settings_plugin.cc.

32 {
33 switch (color_scheme) {
34 case FL_COLOR_SCHEME_LIGHT:
35 return kPlatformBrightnessLight;
36 case FL_COLOR_SCHEME_DARK:
37 return kPlatformBrightnessDark;
38 default:
39 g_return_val_if_reached(nullptr);
40 }
41 }

References FL_COLOR_SCHEME_DARK, FL_COLOR_SCHEME_LIGHT, kPlatformBrightnessDark, and kPlatformBrightnessLight.

Referenced by update_settings().

## ◆ update_settings()

static void update_settings | ( | FlSettingsPlugin * | self | ) |
| static

Definition at line 44 of file fl_settings_plugin.cc.

44 {
45 FlClockFormat clock_format = fl_settings_get_clock_format(self->settings);
46 FlColorScheme color_scheme = fl_settings_get_color_scheme(self->settings);
47 gdouble scaling_factor = fl_settings_get_text_scaling_factor(self->settings);
48
49 g_autoptr(FlValue) message = fl_value_new_map();
50 fl_value_set_string_take(message, kTextScaleFactorKey,
51 fl_value_new_float(scaling_factor));
52 fl_value_set_string_take(
53 message, kAlwaysUse24HourFormatKey,
54 fl_value_new_bool(clock_format == FL_CLOCK_FORMAT_24H));
55 fl_value_set_string_take(
56 message, kPlatformBrightnessKey,
57 fl_value_new_string(to_platform_brightness(color_scheme)));
58 fl_basic_message_channel_send(self->channel, message, nullptr, nullptr,
59 nullptr);
60
61 if (self->engine != nullptr) {
62 int32_t flags = 0;
63 if (!fl_settings_get_enable_animations(self->settings)) {
64 flags |= kFlutterAccessibilityFeatureDisableAnimations;
65 }
66 if (fl_settings_get_high_contrast(self->settings)) {
67 flags |= kFlutterAccessibilityFeatureHighContrast;
68 }
69 fl_engine_update_accessibility_features(self->engine, flags);
70 }
71 }

References fl_basic_message_channel_send(), FL_CLOCK_FORMAT_24H, fl_engine_update_accessibility_features(), fl_settings_get_clock_format(), fl_settings_get_color_scheme(), fl_settings_get_enable_animations(), fl_settings_get_high_contrast(), fl_settings_get_text_scaling_factor(), fl_value_new_bool(), fl_value_new_float(), fl_value_new_map(), fl_value_new_string(), fl_value_set_string_take(), flags, kAlwaysUse24HourFormatKey, kPlatformBrightnessKey, kTextScaleFactorKey, self, and to_platform_brightness().

Referenced by fl_settings_plugin_start().

## Variable Documentation

## ◆ kAlwaysUse24HourFormatKey

constexpr char kAlwaysUse24HourFormatKey[] = "alwaysUse24HourFormat"
| staticconstexpr

Definition at line 17 of file fl_settings_plugin.cc.

Referenced by update_settings().

## ◆ kChannelName

constexpr char kChannelName[] = "flutter/settings"
| staticconstexpr

Definition at line 15 of file fl_settings_plugin.cc.

Referenced by fl_settings_plugin_new().

## ◆ kPlatformBrightnessDark

constexpr char kPlatformBrightnessDark[] = "dark"
| staticconstexpr

Definition at line 20 of file fl_settings_plugin.cc.

Referenced by to_platform_brightness().

## ◆ kPlatformBrightnessKey

constexpr char kPlatformBrightnessKey[] = "platformBrightness"
| staticconstexpr

Definition at line 18 of file fl_settings_plugin.cc.

Referenced by update_settings().

## ◆ kPlatformBrightnessLight

constexpr char kPlatformBrightnessLight[] = "light"
| staticconstexpr

Definition at line 19 of file fl_settings_plugin.cc.

Referenced by to_platform_brightness().

## ◆ kTextScaleFactorKey

constexpr char kTextScaleFactorKey[] = "textScaleFactor"
| staticconstexpr

Definition at line 16 of file fl_settings_plugin.cc.

Referenced by update_settings().

fl_engine_update_accessibility_features
void fl_engine_update_accessibility_features(FlEngine *self, int32_t flags)
Definition: fl_engine.cc:924
fl_settings_get_color_scheme
FlColorScheme fl_settings_get_color_scheme(FlSettings *self)
Definition: fl_settings.cc:34
fl_value_set_string_take
G_MODULE_EXPORT void fl_value_set_string_take(FlValue *self, const gchar *key, FlValue *value)
Definition: fl_value.cc:610
fl_basic_message_channel_send
G_MODULE_EXPORT void fl_basic_message_channel_send(FlBasicMessageChannel *self, FlValue *message, GCancellable *cancellable, GAsyncReadyCallback callback, gpointer user_data)
Definition: fl_basic_message_channel.cc:226
FL_CLOCK_FORMAT_24H
@ FL_CLOCK_FORMAT_24H
Definition: fl_settings.h:24
to_platform_brightness
static const gchar * to_platform_brightness(FlColorScheme color_scheme)
Definition: fl_settings_plugin.cc:32
fl_value_new_bool
G_MODULE_EXPORT FlValue * fl_value_new_bool(bool value)
Definition: fl_value.cc:244
FlValue
typedefG_BEGIN_DECLS struct _FlValue FlValue
Definition: fl_value.h:40
fl_json_message_codec_new
G_MODULE_EXPORT FlJsonMessageCodec * fl_json_message_codec_new()
Definition: fl_json_message_codec.cc:306
fl_settings_get_enable_animations
gboolean fl_settings_get_enable_animations(FlSettings *self)
Definition: fl_settings.cc:38
flags
FlutterSemanticsFlag flags
Definition: fl_accessible_node.cc:105
update_settings
static void update_settings(FlSettingsPlugin *self)
Definition: fl_settings_plugin.cc:44
fl_engine_get_binary_messenger
G_MODULE_EXPORT FlBinaryMessenger * fl_engine_get_binary_messenger(FlEngine *self)
Definition: fl_engine.cc:902
kChannelName
static constexpr char kChannelName[]
Definition: fl_settings_plugin.cc:15
kPlatformBrightnessLight
static constexpr char kPlatformBrightnessLight[]
Definition: fl_settings_plugin.cc:19
kPlatformBrightnessDark
static constexpr char kPlatformBrightnessDark[]
Definition: fl_settings_plugin.cc:20
fl_settings_plugin_dispose
static void fl_settings_plugin_dispose(GObject *object)
Definition: fl_settings_plugin.cc:73
FlColorScheme
FlColorScheme
Definition: fl_settings.h:35
fl_value_new_map
G_MODULE_EXPORT FlValue * fl_value_new_map()
Definition: fl_value.cc:355
fl_settings_get_high_contrast
gboolean fl_settings_get_high_contrast(FlSettings *self)
Definition: fl_settings.cc:42
kPlatformBrightnessKey
static constexpr char kPlatformBrightnessKey[]
Definition: fl_settings_plugin.cc:18
g_object_add_weak_pointer
g_object_add_weak_pointer(G_OBJECT(self), reinterpret_cast< gpointer * >(&self->engine))
fl_settings_get_text_scaling_factor
gdouble fl_settings_get_text_scaling_factor(FlSettings *self)
Definition: fl_settings.cc:46
kTextScaleFactorKey
static constexpr char kTextScaleFactorKey[]
Definition: fl_settings_plugin.cc:16
self
GdkEvent FlView * self
Definition: fl_view.cc:100
FL_COLOR_SCHEME_LIGHT
@ FL_COLOR_SCHEME_LIGHT
Definition: fl_settings.h:37
FL_COLOR_SCHEME_DARK
@ FL_COLOR_SCHEME_DARK
Definition: fl_settings.h:38
fl_value_new_float
G_MODULE_EXPORT FlValue * fl_value_new_float(double value)
Definition: fl_value.cc:258
engine
FlEngine * engine
Definition: fl_view_accessible.cc:29
fl_basic_message_channel_new
G_MODULE_EXPORT FlBasicMessageChannel * fl_basic_message_channel_new(FlBinaryMessenger *messenger, const gchar *name, FlMessageCodec *codec)
Definition: fl_basic_message_channel.cc:154
kAlwaysUse24HourFormatKey
static constexpr char kAlwaysUse24HourFormatKey[]
Definition: fl_settings_plugin.cc:17
FlClockFormat
FlClockFormat
Definition: fl_settings.h:21
fl_settings_get_clock_format
FlClockFormat fl_settings_get_clock_format(FlSettings *self)
Definition: fl_settings.cc:30
fl_value_new_string
G_MODULE_EXPORT FlValue * fl_value_new_string(const gchar *value)
Definition: fl_value.cc:265